Shimmering = class(Turbine.UI.Window);

function Shimmering:Constructor()
    Turbine.UI.Window.Constructor(self);
    
    self.controls = {};
    self.updateTime = 0;
    self.theta = 0;
end

function Shimmering:Add(control)
    local gameTime = Turbine.Engine.GetGameTime();
    local color = control:GetForeColor();
    self.controls[control] = { color.A, color.R, color.G, color.B };
end

function Shimmering:Remove(control)
    local color = self.controls[control];
    if (color) then
        local color = Turbine.UI.Color(unpack(color));
        control:SetForeColor(color);
        self.controls[control] = nil;
    end
end

function Shimmering:Update()
    local gameTime = Turbine.Engine.GetGameTime();
    local elapsedTime = (gameTime - self.updateTime) * 5;
    self.theta = self.theta + elapsedTime;
    local stage, progress = math.modf(self.theta % 2);
    if (stage == 1) then
        progress = 1 - progress;
    end
    local R = 0.5 + 0.5 * progress;
    local G = 0.5 + 0.5 * progress;
    local B = 0.5 - 0.5 * progress;
    local color = Turbine.UI.Color(1, R, G, B);
    for ctl, info in pairs(self.controls) do
        ctl:SetForeColor(color);
    end
    self.updateTime = gameTime;
end
